import { LocationQueryValue } from 'vue-router';

declare function arrayParam<TParam>(elementConfig: ParamSerializationConfig<TParam>): ParamSerializationConfig<NonNullable<TParam>[] | undefined>;

declare const booleanParam: ParamSerializationConfigBuilder<boolean | undefined>;

declare enum DateParamType {
    Date = 0,
    DateTime = 1
}
type DateParamOptions = {
    dateType: DateParamType;
};
declare const dateParam: ParamSerializationConfigBuilder<Date | undefined, DateParamOptions>;

declare const numberParam: ParamSerializationConfigBuilder<number | undefined>;

declare function objectParam<TObject>(): ParamSerializationConfig<TObject | undefined>;

declare const stringParam: ParamSerializationConfigBuilder<string | undefined>;

type ParamSerializationConfig<TParam> = {
    serialize: (value: TParam | undefined) => LocationQueryValue | LocationQueryValue[];
    deserialize: (value: LocationQueryValue | LocationQueryValue[]) => TParam;
};
type ParamSerializationConfigBuilder<TParam, TOptions = {}> = (options?: TOptions) => ParamSerializationConfig<TParam>;

export { DateParamType, type ParamSerializationConfig, type ParamSerializationConfigBuilder, arrayParam, booleanParam, dateParam, numberParam, objectParam, stringParam };
